package dev.shadowsoffire.apotheosis.adventure.affix;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import java.util.Map;
import java.util.function.BiConsumer;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.util.Mth;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.MobType;
import net.minecraft.world.entity.ai.attributes.Attribute;
import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.context.UseOnContext;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.phys.HitResult;

public final class AffixInstance extends Record {
  private final DynamicHolder<? extends Affix> affix;
  
  private final ItemStack stack;
  
  private final DynamicHolder<LootRarity> rarity;
  
  private final float level;
  
  public AffixInstance(DynamicHolder<? extends Affix> affix, ItemStack stack, DynamicHolder<LootRarity> rarity, float level) {
    this.affix = affix;
    this.stack = stack;
    this.rarity = rarity;
    this.level = level;
  }
  
  public final String toString() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> toString : (Ldev/shadowsoffire/apotheosis/adventure/affix/AffixInstance;)Ljava/lang/String;
    //   6: areturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #38	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/affix/AffixInstance;
  }
  
  public final int hashCode() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> hashCode : (Ldev/shadowsoffire/apotheosis/adventure/affix/AffixInstance;)I
    //   6: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #38	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/affix/AffixInstance;
  }
  
  public final boolean equals(Object o) {
    // Byte code:
    //   0: aload_0
    //   1: aload_1
    //   2: <illegal opcode> equals : (Ldev/shadowsoffire/apotheosis/adventure/affix/AffixInstance;Ljava/lang/Object;)Z
    //   7: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #38	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	8	0	this	Ldev/shadowsoffire/apotheosis/adventure/affix/AffixInstance;
    //   0	8	1	o	Ljava/lang/Object;
  }
  
  public DynamicHolder<? extends Affix> affix() {
    return this.affix;
  }
  
  public ItemStack stack() {
    return this.stack;
  }
  
  public DynamicHolder<LootRarity> rarity() {
    return this.rarity;
  }
  
  public float level() {
    return this.level;
  }
  
  public boolean isValid() {
    return (this.affix.isBound() && this.rarity.isBound());
  }
  
  private Affix afx() {
    return (Affix)this.affix.get();
  }
  
  private LootRarity rty() {
    return (LootRarity)this.rarity.get();
  }
  
  public void addModifiers(EquipmentSlot type, BiConsumer<Attribute, AttributeModifier> map) {
    afx().addModifiers(this.stack, rty(), this.level, type, map);
  }
  
  public MutableComponent getDescription() {
    return afx().getDescription(this.stack, rty(), this.level);
  }
  
  public Component getAugmentingText() {
    return afx().getAugmentingText(this.stack, rty(), this.level);
  }
  
  public Component getName(boolean prefix) {
    return afx().getName(prefix);
  }
  
  public int getDamageProtection(DamageSource source) {
    return afx().getDamageProtection(this.stack, rty(), this.level, source);
  }
  
  public float getDamageBonus(MobType creatureType) {
    return afx().getDamageBonus(this.stack, rty(), this.level, creatureType);
  }
  
  public void doPostAttack(LivingEntity user, @Nullable Entity target) {
    afx().doPostAttack(this.stack, rty(), this.level, user, target);
  }
  
  public void doPostHurt(LivingEntity user, @Nullable Entity attacker) {
    afx().doPostHurt(this.stack, rty(), this.level, user, attacker);
  }
  
  public void onArrowFired(LivingEntity user, AbstractArrow arrow) {
    afx().onArrowFired(this.stack, rty(), this.level, user, arrow);
  }
  
  @Nullable
  public InteractionResult onItemUse(UseOnContext ctx) {
    return afx().onItemUse(this.stack, rty(), this.level, ctx);
  }
  
  public float onShieldBlock(LivingEntity entity, DamageSource source, float amount) {
    return afx().onShieldBlock(this.stack, rty(), this.level, entity, source, amount);
  }
  
  public void onBlockBreak(Player player, LevelAccessor world, BlockPos pos, BlockState state) {
    afx().onBlockBreak(this.stack, rty(), this.level, player, world, pos, state);
  }
  
  public float getDurabilityBonusPercentage(@Nullable ServerPlayer user) {
    return afx().getDurabilityBonusPercentage(this.stack, rty(), this.level, user);
  }
  
  public void onArrowImpact(AbstractArrow arrow, HitResult res, HitResult.Type type) {
    afx().onArrowImpact(arrow, rty(), this.level, res, type);
  }
  
  public boolean enablesTelepathy() {
    return afx().enablesTelepathy();
  }
  
  public float onHurt(DamageSource src, LivingEntity ent, float amount) {
    return afx().onHurt(this.stack, rty(), this.level, src, ent, amount);
  }
  
  public void getEnchantmentLevels(Map<Enchantment, Integer> enchantments) {
    afx().getEnchantmentLevels(this.stack, rty(), this.level, enchantments);
  }
  
  public void modifyLoot(ObjectArrayList<ItemStack> loot, LootContext ctx) {
    afx().modifyLoot(this.stack, rty(), this.level, loot, ctx);
  }
  
  public dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance withNewLevel(float level) {
    return new dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance(this.affix, this.stack, this.rarity, Mth.m_14036_(level, 0.0F, 1.0F));
  }
}
